function dags = bootstrap_build_all_DAGs(N,flag)

if nargin>1
    if strcmp(flag, 'load_saved')
        if exist(['alldags_' num2str(N) '.mat'])==2
            display(['loading dags from ' ['alldags_' num2str(N) '.mat'] '...']);
            load(['alldags_' num2str(N) '.mat']);
            %         load(['compliance_' num2str(N) '.mat']);
            %         load('theories.mat');
            return;
        end
    end
end

if N==2
    dags=[dg2ind([0])];
else
    %load/build smaller dags:
    if exist(['alldags_' num2str(N-1) '.mat'])==2
        display(['loading dags from ' ['alldags_' num2str(N-1) '.mat'] '...']);
        load(['alldags_' num2str(N-1) '.mat']); %load already computed (N-1)x(N-1) dags
    else
        dags = bootstrap_build_all_DAGs(N-1);
    end
end

display(['building dags on ' num2str(N) ' nodes...']);
tic

% A_vects=bin_ind2vec((1:2^N)', N);

%now use the smaller dags to build bigger dags:
smaller_dags=dags; %this is the (N-1)x(N-1) dags.
dags=[];

for base_dag_ind = smaller_dags
    base_dag = ind2dg(base_dag_ind, N-1);
    
    for i=1:2^(N-1)  %indices for new row
        for j=1:2^(N-1)  %indices for new column
            new_dag = [[base_dag; bin_ind2vec(i, N-1)] [bin_ind2vec(j,N-1) 0]'];
            if check_cyclic(new_dag) ~= -1
                dags = [dags dg2ind(new_dag)];
            end
        end
    end
end

% rule_compliance=zeros(length(dags),2^N);
% for d=1:length(dags)
%     for a=1:2^N
%         rule_compliance(d,:,a) = N_ruler_check(new_dag,A_vects(a,:));
%     end
% end
% 
% 
% %change the rule-compliance matrix into a theory-compliance matrix (dags X
% %theories X action_sets):
% laws=size(rule_compliance,2);
% theory_set=bin_ind2vec((1:2^laws)', laws); %all possible combinations of laws...
% num_action_sets = size(rule_compliance,3);
% theory_compliance = zeros(size(rule_compliance,1), size(theory_set,1), num_action_sets);
% num_rules_in_theory = sum(theory_set,2);
% for a=1:num_action_sets
%     %the number of satified rules that are in each theory, for each dag (fixed action_set):
%     num_rules_sat_theory = rule_compliance(:,:,a)*(theory_set');
%     theory_compliance(:,:,a) = (num_rules_sat_theory == repmat(num_rules_in_theory',size(num_rules_sat_theory,1),1) );
% end


toc

save(['alldags_' num2str(N)], 'dags');
% save(['compliance_' num2str(N)], 'theory_compliance');
% save('theories', 'theory_set');

