function [systems_and_samples, system_dags, CPT] = ...
    forward_all(parameters,num_of_vars,num_of_systems,num_of_samples,dags,theory_compliance,theory_ind,action_set_ind)

% This function generates several systems for a particular theory, and then
% generates samples for each one of those systems. 

systems_and_samples = zeros(num_of_samples,num_of_vars,num_of_systems);

%which dags satisfy the theory?
%a dag satisfies a theory if it satisfies all the laws in the theory (it
%can satify other laws as well....

if iscell(theory_compliance)
    theory_compliance=theory_compliance{1}; %%FIXME
end

theory_and_action_complying_dags = (theory_compliance(:,theory_ind,action_set_ind)>0);
satisfying_dags = dags( theory_and_action_complying_dags);

CPT={};
system_dags=zeros(1,num_of_systems);

%each system is a randomly sampled satisfying dag with random CPT:
for i=1:num_of_systems
  
    system_selected =random('unid',length(satisfying_dags));
    
    system_dags(i)=satisfying_dags(system_selected);
    
    dag = ind2dg(system_dags(i), num_of_vars);
    
    switch parameters.cpt_model
        case 'beta'
            CPT{i}=get_cpt(dag, parameters);
        case 'noisy-or'
            CPT{i} = get_cpt_noisyor(dag,parameters);
        case 'noisy-or-and-not'
            CPT{i} = get_cpt_noisyor_andnot(dag,parameters,bin_ind2vec(action_set_ind,num_of_vars));
        otherwise
            CPT{i}=get_cpt(dag, parameters);
    end
    
    systems_and_samples(:,:,i) = forward_dag(dag, CPT{i}, num_of_samples);

end


