function [samples] = forward_dag(dag,C,samples_size)
% This will generate a CPT such that for each node we have the
% coin weight it's supposed to get, for every setting of the parents.
% Parentless nodes have just one coin weight, nodes with parents have
% num_of_node^num_of_parents weights associated with them. Later we will
% use this as a forward mode to generate data from a particular dag.


sorted_dag = toposort(dag);

samples = zeros(samples_size,length(sorted_dag));


for j= 1:samples_size
    
    for i = 1:length(sorted_dag)
        
        % in order to access the 'right' weight in the table C, we need a
        % way of ordering parent values. we use the binary sorting because
        % we assume parents can only take on 0 and 1.
        parents_values = samples(j,logical(dag(:,sorted_dag(i))));
        samples(j,sorted_dag(i)) = flip( C{sorted_dag(i)}(bin_vec2ind(parents_values)) );
        
    end
end


%
% % % % for i = 1:length(sorted_dag)
% % % %
% % % %     C{sorted_dag(i)} = random('beta',alpha,beta,numn^num_parents(sorted_dag(i)),1);
% % % %
% % % % end
%
% % first we get the values for the non-parent assignments.
% for j= 1:samples_size
%
% for i = 1:length(sorted_dag)
%
%     if num_parents(sorted_dag(i)) == 0
%     samples(j,sorted_dag(i)) = flip(C{sorted_dag(i)});
%     end
%
% end
% end
%
% % now we go through the nodes with parents
% for j= 1:samples_size
%
% for i = 1:length(sorted_dag)
%
%     if num_parents(sorted_dag(i)) ~= 0
%         % in order to access the 'right' weight in the table C, we need a
%         % way of ordering parent values. we use the binary sorting because
%         % we assume parents can only take on 0 and 1.
%         parents_values = samples(j,logical(dag(:,sorted_dag(i))));
%         samples(j,sorted_dag(i)) = flip( C{sorted_dag(i)}(bin2dec(num2str(parents_values))+1) );
%     end
%
% end
% end