%%minimal nativism figures

th={};
runs={'big_run', 'run_mn_0', 'run_mn_1', 'run_mn_2', 'run_mn_3', 'run_mn_4'};
for r=1:length(runs)
load([runs{r} '.mat']);
th{r}=theory_log_prob;
th_set{r}=theory_set;
ts{r}=total_samples;
end
% load run_mn_1.mat
% th{2}=theory_log_prob;
% th_set{2}=theory_set;
% load run_mn_2.mat
% th{3}=theory_log_prob;
% th_set{3}=theory_set;
% load run_mn_3.mat
% th{4}=theory_log_prob;
% th_set{4}=theory_set;
% load run_mn_4.mat
% th{5}=theory_log_prob;
% th_set{5}=theory_set;

%find the marginal probability of theories with the first two laws:
tth_marginal_posterior={};
for r=1:length(th)
    target_theories= (th_set{r}(:,1)==1 & th_set{r}(:,2)==1);
for i=1:size(th{r},3)
    tth_marginal_posterior{r}(:,i) = exp(th{r}(:,:,i)')*target_theories;
end
end


figure;
set(gcf,...'DefaultAxesColorOrder',[0 0 0],...
    'DefaultAxesLineStyleOrder','-|--|:|-.')
% mean_th_marg=squeeze(mean(tth_marginal_posterior,2));
semilogx(ts{1}, squeeze(mean(tth_marginal_posterior{1},2)), '-',...
    total_samples, squeeze(mean(tth_marginal_posterior{4},2)), '-', ...
    total_samples, squeeze(mean(tth_marginal_posterior{3},2)), '--', ...
    total_samples, squeeze(mean(tth_marginal_posterior{6},2)), '--', ...
    total_samples, squeeze(mean(tth_marginal_posterior{5},2)), '--', ...
    total_samples, squeeze(mean(tth_marginal_posterior{2},2)), '-.', ...
    'LineWidth', 2);
xlim([min(total_samples) max(total_samples)]);
set(gca,'FontSize', 16, 'FontName', 'Times');
legend({'F1 100%, F2 0%', ...
        'F1 50%, F2 50%', ...
        'F1 50%, F2 0%',...
        'F1 50%, F2 25% (overlapping)', ...
        'F1 25%, F2 25%', ...
        'F1 and F2 both 0%' ...
        }, ...
        'FontSize', 16, 'FontName', 'Times', 'Location', 'NorthWest');
xlabel('Total # samples', 'FontSize', 20, 'FontName', 'Times');
ylabel('Marginal posterior of corect abstraction', 'FontSize', 20, 'FontName', 'Times');
% set(gcf,'PaperPositionMode','auto');
orient landscape;
print -dpdf minnatfig.pdf;
