function [rankd rankt theory_log_prob postd] = ...
    score_and_rank(dags, system_dags, theory_set, scores, theory_compliance, data_sets_per_system, theories_of_interest, parameters, theory_compliance_per_system)


% num_dags = size(data_log_prob,1);
num_systems = size(scores,2);
% num_data_sets = size(data_log_prob,3);
% num_theories = size(theory_set,1);


if isfield(parameters, 'config') && strcmp(parameters.config, 'small_memory')
    display('Using theory_log_posterior_loop_systems to minimize memory usage.');
    [theory_log_prob dag_post_given_th dag_marg_pos] = ...
        theory_log_posterior_loop_systems(theory_set, scores, theory_compliance, data_sets_per_system, theories_of_interest, theory_compliance_per_system);
else
    [theory_log_prob dag_post_given_th dag_marg_pos] = ...
        theory_log_posterior(theory_set, scores, theory_compliance, data_sets_per_system, theories_of_interest);
end

for s=1:num_systems
    f=find(dags==system_dags(s));
    
    %learned theory, including actions:
    [sorted Indexes] = sort( squeeze(dag_marg_pos(:,s,:)), 1, 'descend' );
    [rankd(s,:,1+length(theories_of_interest)) K] = find(Indexes==f);
    
    postd(s,:,1+length(theories_of_interest))=dag_marg_pos(f,s,:);
end


for t=1:length(theories_of_interest)
    
    [sorted Indexes] = sort(theory_log_prob(:,:), 1, 'descend' );
    [rankt(:,t) K] = find(Indexes==theories_of_interest(t));
    
    for s=1:num_systems
        f=find(dags==system_dags(s));
                
        [sorted Indexes] = sort( squeeze(dag_post_given_th(:,s,:,t)), 1, 'descend' );
        [rankd(s,:,t) K] = find(Indexes==f);
        
        postd(s,:,t)=dag_post_given_th(f,s,:,t);
    end
    
end
