function [score cache count_score_cache] = score_using_cache(DAG, data_samples, parameters, cache, count_score_cache)
% This function returns the log-liklihood of a particular DAG for each prefix of 
% given data samples, by using cached scores in cache.
% returns the vector of scores for this DAG on prefixes of the
% data_samples, as determined by parameters.score_data_at.

if isempty(cache)
    [cache count_score_cache] = build_score_cache(data_samples, parameters, count_score_cache);
end

num_data_sets = length(parameters.score_data_at);
score=zeros(num_data_sets,1);

% find the location of  parents in the dag
parents_index = bin_vec2ind(DAG');

for i=1:length(DAG) % iterate over the variables: columns give the parents of the variable.
    
    score = score + cache.scores{parents_index(i)}(:,cache.vars{parents_index(i)}==i);

end